<template>
  <component
    is="a-modal"
    :width="tool.getDevice() === 'mobile' ? '100%' : '600px'"
    v-model:visible="visible"
    :title="title"
    :mask-closable="false"
    :ok-loading="loading"
    @cancel="close"
    @before-ok="submit">
    <!-- 表单信息 start -->
    <a-form ref="formRef" :model="formData" :rules="rules" :auto-label-width="true">
      <a-form-item label="媒体名称" field="name">
        <a-input v-model="formData.name" placeholder="请输入媒体名称" />
      </a-form-item>
      <a-form-item label="媒体渠道简称" field="channel_name">
        <a-input v-model="formData.channel_name" placeholder="请输入媒体渠道简称" />
      </a-form-item>
      <a-form-item label="安卓监测链接" field="andurl">
        <a-input v-model="formData.andurl" placeholder="请输入安卓监测链接" />
      </a-form-item>
      <a-form-item label="ios监测链接" field="iosurl">
        <a-input v-model="formData.iosurl" placeholder="请输入ios监测链接" />
      </a-form-item>
      <a-form-item label="小游戏监测链接" field="xyxurl">
        <a-input v-model="formData.xyxurl" placeholder="请输入小游戏监测链接" />
      </a-form-item>
      <a-form-item label="小游戏路径参数补充" field="appleturl">
        <a-input v-model="formData.appleturl" placeholder="请输入小游戏路径参数补充" />
      </a-form-item>
      <a-form-item label="状态" field="state">
        <sa-radio v-model="formData.state" dict="nomal_or_stop" />
      </a-form-item>
    </a-form>
    <!-- 表单信息 end -->
  </component>
</template>

<script setup>
import { ref, reactive, computed } from 'vue'
import tool from '@/utils/tool'
import { Message, Modal } from '@arco-design/web-vue'
import api from '../../api/advert/mediaList'

const emit = defineEmits(['success'])
// 引用定义
const visible = ref(false)
const loading = ref(false)
const formRef = ref()
const mode = ref('')

let title = computed(() => {
  return '广告媒体表' + (mode.value == 'add' ? '-新增' : '-编辑')
})

// 表单初始值
const initialFormData = {
  id: null,
  name: '',
  channel_name: '',
  andurl: '',
  iosurl: '',
  xyxurl: '',
  appleturl: '',
  state: 1,
}

// 表单信息
const formData = reactive({ ...initialFormData })

// 验证规则
const rules = {
  name: [{ required: true, message: '媒体名称必需填写' }],
  channel_name: [{ required: true, message: '媒体渠道简称必需填写' }],
  andurl: [{ required: true, message: '安卓监测链接必需填写' }],
  iosurl: [{ required: true, message: 'ios监测链接必需填写' }],
  xyxurl: [{ required: true, message: '小游戏监测链接必需填写' }],
  appleturl: [{ required: true, message: '小游戏路径参数补充必需填写' }],
  state: [{ required: true, message: '状态必需填写' }],
}

// 打开弹框
const open = async (type = 'add') => {
  mode.value = type
  // 重置表单数据
  Object.assign(formData, initialFormData)
  formRef.value.clearValidate()
  visible.value = true
  await initPage()
}

// 初始化页面数据
const initPage = async () => {}

// 设置数据
const setFormData = async (data) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      formData[key] = data[key]
    }
  }
}

// 数据保存
const submit = async (done) => {
  const validate = await formRef.value?.validate()
  if (!validate) {
    loading.value = true
    let data = { ...formData }
    let result = {}
    if (mode.value === 'add') {
      // 添加数据
      data.id = undefined
      result = await api.save(data)
    } else {
      // 修改数据
      result = await api.update(data.id, data)
    }
    if (result.code === 200) {
      Message.success('操作成功')
      emit('success')
      done(true)
    }
    // 防止连续点击提交
    setTimeout(() => {
      loading.value = false
    }, 500)
  }
  done(false)
}

// 关闭弹窗
const close = () => (visible.value = false)

defineExpose({ open, setFormData })
</script>
